#ifndef ENUMERATE_H
#define ENUMERATE_H

#include "mat.h"
#include "coxeter.h"

#include <mps/mps.h>

struct tracedata {
	int id;
	NUMBER tr;
	NUMBER trinv;
};

void enumerate_coxeter_group(group_t *group, mat *gen, mat *matrices, const int *idlist, int nlist);
int enumerate_coxeter_group_traces(group_t *group, mat *gen, struct tracedata **traces_out, const int *idlist, int nlist, int unique);

void enumerate_tracedata_clear(struct tracedata *traces, int n);

int solve_characteristic_polynomial_d(mps_context *solv, mps_monomial_poly *poly, double tr_real, double tr_imag, double trinv_real, double trinv_imag, double *eigenvalues_real, double *eigenvalues_imag);

#endif
